﻿using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Win32.SafeHandles;
using System.Runtime.InteropServices;
using System.Net;

namespace PortIOSample
{
    class PortIOLib : IDisposable
    {
        const uint IOCTL_WRITE_PROCESSID = 0x9c402414;

        SafeFileHandle fileHandle;

        public PortIOLib()
        {
        }

        public PortIOLib(bool initialize)
        {
            if (initialize == true)
            {
                InitializePortIO();
            }
        }

        public bool InitializePortIO()
        {
            Dispose();

            fileHandle = Kernel32.CreateFile(@"\\.\PortIO", NativeFileAccess.FILE_GENERIC_READ,
                NativeFileShare.NONE, IntPtr.Zero, NativeFileMode.OPEN_EXISTING, NativeFileFlag.FILE_ATTRIBUTE_NORMAL, IntPtr.Zero);

            if (fileHandle.IsInvalid == true)
            {
                return false;
            }

            return true;
        }

        public void Dispose()
        {
            if (fileHandle != null)
            {
                fileHandle.Close();
                fileHandle = null;
            }
        }

        public bool Terminate(int processId)
        {
            if (fileHandle == null || fileHandle.IsInvalid == true)
            {
                return false;
            }

            byte[] inBuffer = BitConverter.GetBytes(processId);
            int pBytesReturned;

            return Kernel32.DeviceIoControl(fileHandle, IOCTL_WRITE_PROCESSID, inBuffer, inBuffer.Length, inBuffer, inBuffer.Length,
                out pBytesReturned, IntPtr.Zero);
        }
    }
}
