﻿using System;
using System.Diagnostics;

namespace PortIOSample
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("Version 1.5");

            if (args.Length < 1)
            {
                Console.WriteLine("PortIOSample [pid]");
                Console.WriteLine("PortIOSample /n [processname]");
                return;
            }

            int pid = 0;

            if (args.Length == 1)
            {
                if (Int32.TryParse(args[0], out pid) == true)
                {
                    TerminateProcess(pid);
                }
            }
            else if (args.Length == 2)
            {
                Process[] targetExePids = Process.GetProcessesByName(args[1]);
                foreach (Process proc in targetExePids)
                {
                    TerminateProcess(proc.Id);
                }
            }
        }

        private static void TerminateProcess(int pid)
        {
            using (PortIOLib portIoLib = new PortIOLib(true))
            {
                Console.WriteLine(pid + ": " + portIoLib.Terminate(pid));
            }
        }
    }
}
